;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************








opcode_DEC:

opcode_DEC_ZP:
			movw ZL, reg_PCL
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZP

	opc_DEC_ZP_1:
			dec oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp mod_write_ZP

opcode_DEC_ZPX:
			movw ZL, reg_PCL
			ldi loop, 6*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZPX

			dec oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp mod_write_ZP



opcode_DEC_Abs:
			movw ZL, reg_PCL
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute

			andi reg_Status, 0b11111001


		opc_DEC_Abs_1:
			dec oparand
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp mod_write_Absolute
			
opcode_DEC_Abs_X:
			movw ZL, reg_PCL
			ldi loop, 6*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_X

			andi reg_Status, 0b11111001
			dec oparand
			in temp, SREG
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp mod_write_Absolute







opcode_INC:

opcode_INC_ZP:
			movw ZL, reg_PCL
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZP


	opc_INC_ZP_1:
			inc oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp mod_write_ZP

opcode_INC_ZPX:
			movw ZL, reg_PCL
			ldi loop, 6*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_ZPX

			inc oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp mod_write_ZP



opcode_INC_Abs:
			movw ZL, reg_PCL
			ldi loop, 5*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute


		opc_INC_Abs_1:
			inc oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp mod_write_Absolute
			
opcode_INC_Abs_X:
			movw ZL, reg_PCL
			ldi loop, 6*MHz
			add SyncL, loop
			adc SyncH, zero
			rcall read_Absolute_X
			inc oparand
			in temp, SREG
			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp mod_write_Absolute







opc_InDe_warte:
			in temp, SREG
			;READ_RDY

			andi reg_Status, 0b11111001
			andi temp, 0b00000110
			or reg_Status, temp
			rjmp main_loop

opcode_DEY:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			dec reg_Y
			rjmp opc_InDe_warte

opcode_INY:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			inc reg_Y
			rjmp opc_InDe_warte

opcode_INX:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			inc reg_X
			rjmp opc_InDe_warte

opcode_DEX:
			movw ZL, reg_PCL
			adiw SyncL, 2*MHz
			dec reg_X
			rjmp opc_InDe_warte





















