;*********************************************************************************************************
;		Zyklengenaue Emulation eines MOS6510 auf einem ATmega
;			(c) Mark Leyer 2010
;*********************************************************************************************************








opcode_BPL:
			sbrs reg_Status, flagN
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BMI:
			sbrc reg_Status, flagN
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BVC:
			sbrs reg_Status2, flagV
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BVS:
			sbrc reg_Status2, flagV
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BCC:
			sbrs reg_Status, flagC
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BCS:
			sbrc reg_Status, flagC
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BNE:
			sbrs reg_Status, flagZ
			rjmp opcodes_branch
			rjmp opcodes_nobranch
opcode_BEQ:
			sbrc reg_Status, flagZ
			rjmp opcodes_branch
			rjmp opcodes_nobranch

opcodes_branch:
			ldi loop, 3*MHz
			add SyncL, loop
			adc SyncH, zero

			movw ZL, reg_PCL		; Z wieder als PC
			READ_RAMROM temp		;6
			;ld temp, X+

			tst temp
			brpl opcode_Branch_2
			neg temp					;????
			sub ZL, temp
			brcs opcode_Branch_3
			;movw ZL, reg_PCL
			rjmp main_loop
		opcode_Branch_3:
			sbc ZH, zero
			;movw ZL, reg_PCL
			rjmp main_loop

		opcode_Branch_2:
			add ZL, temp
			brcs opcode_Branch_4
			;movw ZL, reg_PCL
			rjmp main_loop
		opcode_Branch_4:
			adc ZH, zero
			;movw ZL, reg_PCL
			rjmp main_loop

opcodes_nobranch:
			adiw reg_PCL, 0x01
			movw ZL, reg_PCL
			ldi loop, 2*MHz
			add SyncL, loop
			adc SyncH, zero
			rjmp main_loop
		


























